/**
 * \file
 * Interface whose implementations can write from a stream given as
 * a handle.
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __TR_INTERFACE_WRITER_H__
#define __TR_INTERFACE_WRITER_H__

#include <sys/types.h>

#include "trbase.h"
#include "tr/stream.h"

typedef ssize_t (* fptr_TR_streamWriterWrite)(void *, TR_Stream);

TR_INTERFACE(TR_StreamWriter) {
	TR_IFID;
	fptr_TR_streamWriterWrite write;
};

inline
ssize_t
TR_streamWriterWrite(void * object, TR_Stream st)
{
	ssize_t ret;
	TR_RETCALL(object, TR_StreamWriter, write, ret, st);
	return ret;
}

#endif // __TR_INTERFACE_WRITER_H__

// vim: set ts=4 sw=4:
