/**
 * \file
 * Abstraction layer above BSD sockets. Capsules and simplifies connect
 * accept and listen.
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __TR_REMOTE_DATA_H__
#define __TR_REMOTE_DATA_H__

#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>

#include "trbase.h"
#include "tr/socket.h"

TR_CLASS(TR_RemoteData) {
	TR_EXTENDS(TR_SizedData);

	TR_Socket remote;  // TR_Socket might become a more abstract TR_Remote one day.
	int       free_remote;
};
TR_INSTANCE_INIT(TR_RemoteData);
TR_CLASSVARS_DECL(TR_RemoteData) {};

extern TR_RemoteData TR_emptyRemoteData;

#endif // __TR_REMOTE_DATA_H__

// vim: set ts=4 sw=4:

