/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>

#include "trbase.h"

#include "tr/remote_data.h"
#include "tr/socket.h"

static
int
remoteDataCtor(void * _this, va_list * params)
{
	TR_PARENTCALL(TR_RemoteData, _this, TR_Class, ctor, params);
	((TR_RemoteData)_this)->remote = va_arg(*params, TR_Socket);

	return 0;
}

static
void
remoteDataDtor(void * _this) {
	TR_PARENTCALL(TR_RemoteData, _this, TR_Class, dtor);

	if (((TR_RemoteData)_this)->free_remote) {
		TR_delete(((TR_RemoteData)_this)->remote);
	}
}

TR_INIT_IFACE(TR_Class, remoteDataCtor, remoteDataDtor, NULL);
TR_CREATE_CLASS(TR_RemoteData, TR_SizedData, NULL, TR_IF(TR_Class));

TR_INSTANCE(
		TR_RemoteData, TR_emptyRemoteData,
		.remote = NULL, .free_remote = 0 );

// vim: set ts=4 sw=4:
